/* node - autor : Ioan Stoianov */

import java.awt.Color;
import java.awt.Graphics;

class graph
{
    public node[] nodes = new node[18];
    int x;
    int y;
    int width;
    int height;
    public int count;
    int maxNodes;
    int maxCols;
    int maxNodesInCols;
    boolean exactly;
    final char labels[] = {' ','A','B','C','D','E','F','G','H','I','J'};
    
    public graph(int x, int y, int width, int height) {
	this.x = x;
	this.y = y;
	this.width = width;
	this.height = height;
	this.maxNodes = 18;
	this.maxCols = 6;
	this.maxNodesInCols = 3;
	this.exactly = false;
    }
    
    public void setMaximumNodes(int mNodes, int mCols, int mNodesInCols,
				boolean exact) {
	if (maxNodes <= 18)
	    maxNodes = mNodes;
	if (maxCols <= 6)
	    maxCols = mCols;
	if (maxNodesInCols <= 6)
	    mNodesInCols = mNodesInCols;
	exactly = exact;
    }
    
    public void putRandomNodes() {
	node[][] nodeAr = new node[6][6];
	int counter = 0;
	for (int loop1 = 0; loop1 < 6; loop1++) {
	    for (int loop2 = 0; loop2 < 6; loop2++)
		nodeAr[loop1][loop2] = new node();
	}
	do {
	    for (int loop = 0; loop < maxCols; loop++) {
		for (int loop1 = 0; loop1 < maxNodesInCols; loop1++) {
		    if (counter < maxNodes) {
			counter++;
			int whichNode
			    = (int) (Math.floor(Math.random() * 5.0) + 1.0);
			if (!nodeAr[whichNode][loop].active)
			    nodeAr[whichNode][loop].setxy
				(counter, (loop * width + x),
				 ((whichNode - 1) * height + y));
			else
			    counter--;
		    }
		}
	    }
	} while (counter < maxNodes && exactly);
	putRandomLines(nodeAr);
	count = 0;
	for (int loop1 = 0; loop1 < 6; loop1++) {
	    for (int loop2 = 0; loop2 < 6; loop2++) {
		if (((node) nodeAr[loop1][loop2]).active) {
		    nodes[count] = nodeAr[loop1][loop2];
		    count++;
		}
	    }
	}
    }
    
    public void putRandomLines(node[][] nodeAr) {
	for (int loop1 = 0; loop1 < 6; loop1++) {
	    for (int loop2 = 0; loop2 < 6; loop2++) {
		if (nodeAr[loop1][loop2].active) {
		    for (int loop3 = loop2 + 1; loop3 < 6; loop3++) {
			if (nodeAr[loop1][loop3].active) {
			    nodeAr[loop1][loop2].rightx
				= nodeAr[loop1][loop3].x;
			    nodeAr[loop1][loop2].righty
				= nodeAr[loop1][loop3].y;
			    nodeAr[loop1][loop2].rightc
				= (int) (Math.floor(Math.random() * 10.0) + 1.0);
			    nodeAr[loop1][loop2].rightn
				= nodeAr[loop1][loop3].number;
			    nodeAr[loop1][loop3].leftx
				= nodeAr[loop1][loop2].x;
			    nodeAr[loop1][loop3].lefty
				= nodeAr[loop1][loop2].y;
			    nodeAr[loop1][loop3].leftc
				= nodeAr[loop1][loop2].rightc;
			    nodeAr[loop1][loop3].leftn
				= nodeAr[loop1][loop2].number;
			    break;
			}
		    }
		    for (int loop3 = loop1 + 1; loop3 < 6; loop3++) {
			if (nodeAr[loop3][loop2].active) {
			    nodeAr[loop1][loop2].downx
				= nodeAr[loop3][loop2].x;
			    nodeAr[loop1][loop2].downy
				= nodeAr[loop3][loop2].y;
			    nodeAr[loop1][loop2].downc
				= (int) (Math.floor(Math.random() * 10.0)
					 + 1.0);
			    nodeAr[loop1][loop2].downn
				= nodeAr[loop3][loop2].number;
			    nodeAr[loop3][loop2].upx
				= nodeAr[loop1][loop2].x;
			    nodeAr[loop3][loop2].upy
				= nodeAr[loop1][loop2].y;
			    nodeAr[loop3][loop2].upc
				= nodeAr[loop1][loop2].downc;
			    nodeAr[loop3][loop2].upn
				= nodeAr[loop1][loop2].number;
			    break;
			}
		    }
		    if (loop1 < 5 && loop2 < 5
			&& nodeAr[loop1 + 1][loop2 + 1].active) {
			nodeAr[loop1][loop2].rightdownx
			    = nodeAr[loop1 + 1][loop2 + 1].x;
			nodeAr[loop1][loop2].rightdowny
			    = nodeAr[loop1 + 1][loop2 + 1].y;
			nodeAr[loop1][loop2].rightdownc
			    = (int) (Math.floor(Math.random() * 10.0) + 1.0);
			nodeAr[loop1][loop2].rightdownn
			    = nodeAr[loop1 + 1][loop2 + 1].number;
			nodeAr[loop1 + 1][loop2 + 1].leftupx
			    = nodeAr[loop1][loop2].x;
			nodeAr[loop1 + 1][loop2 + 1].leftupy
			    = nodeAr[loop1][loop2].y;
			nodeAr[loop1 + 1][loop2 + 1].leftupc
			    = nodeAr[loop1][loop2].rightdownc;
			nodeAr[loop1 + 1][loop2 + 1].leftupn
			    = nodeAr[loop1][loop2].number;
			break;
		    }
		    if (loop1 > 0 && loop2 < 5
			&& nodeAr[loop1 - 1][loop2 + 1].active) {
			nodeAr[loop1][loop2].leftdownx
			    = nodeAr[loop1 - 1][loop2 + 1].x;
			nodeAr[loop1][loop2].leftdowny
			    = nodeAr[loop1 - 1][loop2 + 1].y;
			nodeAr[loop1][loop2].leftdownc
			    = (int) (Math.floor(Math.random() * 10.0) + 1.0);
			nodeAr[loop1][loop2].leftdownn
			    = nodeAr[loop1 - 1][loop2 + 1].number;
			nodeAr[loop1 - 1][loop2 + 1].rightupx
			    = nodeAr[loop1][loop2].x;
			nodeAr[loop1 - 1][loop2 + 1].rightupy
			    = nodeAr[loop1][loop2].y;
			nodeAr[loop1 - 1][loop2 + 1].rightupc
			    = nodeAr[loop1][loop2].leftdownc;
			nodeAr[loop1 - 1][loop2 + 1].rightupn
			    = nodeAr[loop1][loop2].number;
			break;
		    }
		}
	    }
	}
    }
    
    public int[][] getArray(int n) {
	int[][] myArray = new int[n][n];
	for (int loop = 0; loop < count; loop++) {
	    if (nodes[loop].rightx != 0)
		myArray[nodes[loop].number - 1][nodes[loop].rightn - 1]
		    = nodes[loop].rightc;
	    if (nodes[loop].leftx != 0)
		myArray[nodes[loop].number - 1][nodes[loop].leftn - 1]
		    = nodes[loop].leftc;
	    if (nodes[loop].upx != 0)
		myArray[nodes[loop].number - 1][nodes[loop].upn - 1]
		    = nodes[loop].upc;
	    if (nodes[loop].downx != 0)
		myArray[nodes[loop].number - 1][nodes[loop].downn - 1]
		    = nodes[loop].downc;
	    if (nodes[loop].leftdownx != 0)
		myArray[nodes[loop].number - 1][nodes[loop].leftdownn - 1]
		    = nodes[loop].leftdownc;
	    if (nodes[loop].rightdownx != 0)
		myArray[nodes[loop].number - 1][nodes[loop].rightdownn - 1]
		    = nodes[loop].rightdownc;
	    if (nodes[loop].leftupx != 0)
		myArray[nodes[loop].number - 1][nodes[loop].leftupn - 1]
		    = nodes[loop].leftupc;
	    if (nodes[loop].rightupx != 0)
		myArray[nodes[loop].number - 1][nodes[loop].rightupn - 1]
		    = nodes[loop].rightupc;
	}
	return myArray;
    }
    
    public void drawGraph(Graphics g) {
	for (int loop1 = 0; loop1 < count; loop1++) {
	    if (nodes[loop1].rightx != 0) {
		g.drawLine(nodes[loop1].x + 10,
			   nodes[loop1].y + 10,
			   nodes[loop1].rightx + 10,
			   nodes[loop1].righty + 10);
		g.drawString(String.valueOf(nodes[loop1].rightc),
			     (nodes[loop1].x
			      + (nodes[loop1].rightx - nodes[loop1].x) / 2
			      + 4),
			     (nodes[loop1].y + 8));
	    }
	    if (nodes[loop1].downx != 0) {
		g.drawLine(nodes[loop1].x + 10,
			   nodes[loop1].y + 10,
			   nodes[loop1].downx + 10,
			   nodes[loop1].downy + 10);
		g.drawString(String.valueOf(nodes[loop1].downc),
			     nodes[loop1].x + 13,
			     (nodes[loop1].y
			      + (nodes[loop1].downy - nodes[loop1].y) / 2
			      + 20));
	    }
	    if (nodes[loop1].rightdownx != 0) {
		g.drawLine(nodes[loop1].x + 10,
			   nodes[loop1].y + 10,
			   nodes[loop1].rightdownx + 10,
			   nodes[loop1].rightdowny + 10);
		g.drawString(String.valueOf(nodes[loop1].rightdownc),
			     (nodes[loop1].x
			      + (nodes[loop1].rightdownx - nodes[loop1].x) / 2
			      + 7),
			     (nodes[loop1].y
			      + (nodes[loop1].rightdowny - nodes[loop1].y) / 2
			      + 22));
	    }
	    if (nodes[loop1].leftdownx != 0) {
		g.drawLine(nodes[loop1].x + 10,
			   nodes[loop1].y + 10,
			   nodes[loop1].leftdownx + 10,
			   nodes[loop1].leftdowny + 10);
		g.drawString(String.valueOf(nodes[loop1].leftdownc),
			     (nodes[loop1].x
			      + (nodes[loop1].leftdownx - nodes[loop1].x) / 2
			      + 7),
			     (nodes[loop1].y
			      + (nodes[loop1].leftdowny - nodes[loop1].y) / 2
			      + 6));
	    }
	}
	for (int loop1 = 0; loop1 < count; loop1++) {
	    g.setColor(Color.lightGray);
	    g.fillOval(nodes[loop1].x, nodes[loop1].y, 20,
		       20);
	    g.setColor(Color.black);
	    g.drawOval(nodes[loop1].x, nodes[loop1].y, 20,
		       20);
	    g.drawChars(labels, nodes[loop1].number, 1,
			 nodes[loop1].x + 6,
			 nodes[loop1].y + 12);
	}
    }
}
