/* primSolution - autor : Ioan Stoianov */

import java.awt.Color;
import java.awt.Graphics;

class primSolution
{
    final int hx = 320;
    node[] nodes = new node[18];
    node[] used = new node[18];
    int[] fromNode = new int[18];
    int[] costs = new int[18];
    int counter;
    int usedc;
    int insert;
    public int maxCost;
    
    primSolution() {
	for (int loop1 = 0; loop1 < 12; loop1++) {
	    nodes[loop1] = new node();
	    used[loop1] = new node();
	}
    }
    
    public void printCost(Graphics g) {
	g.drawString("Genetic tree cost :" + String.valueOf(maxCost), 340,
		     310);
    }

    
    public void initialize(graph gr) {
	nodes = gr.nodes;
	counter = gr.count;
	used[0] = nodeNumber(1);
	fromNode[0] = -1;
	usedc = 1;
	maxCost = 0;
    }
    
    public boolean isUsed(int number) {
	for (int loop1 = 0; loop1 < usedc; loop1++) {
	    if (used[loop1].number == number)
		return true;
	}
	return false;
    }
    
    public node nodeNumber(int number) {
	for (int loop = 0; loop < counter; loop++) {
	    if (nodes[loop].number == number)
		return nodes[loop];
	}
	return nodes[0];
    }

    public boolean synecticos() {
	for (boolean notEnd = true; notEnd; notEnd = findNextSmallerCost()) {
	    /* empty */
	}
	if (usedc != counter)
	    return false;
	return true;
    }
    
    public boolean findNextSmallerCost() {
	int cost = 1000;
	int fromn = 0;
	if (usedc == counter)
	    return false;
	insert = 0;
	for (int loop1 = 0; loop1 < usedc; loop1++) {
	    if (used[loop1].rightx != 0
		&& !isUsed(used[loop1].rightn)
		&& used[loop1].rightc <= cost) {
		cost = used[loop1].rightc;
		insert = used[loop1].rightn;
		fromn = used[loop1].number;
	    }
	    if (used[loop1].leftx != 0
		&& !isUsed(used[loop1].leftn)
		&& used[loop1].leftc <= cost) {
		cost = used[loop1].leftc;
		insert = used[loop1].leftn;
		fromn = used[loop1].number;
	    }
	    if (used[loop1].upx != 0
		&& !isUsed(used[loop1].upn)
		&& used[loop1].upc <= cost) {
		cost = used[loop1].upc;
		insert = used[loop1].upn;
		fromn = used[loop1].number;
	    }
	    if (used[loop1].downx != 0
		&& !isUsed(used[loop1].downn)
		&& used[loop1].downc <= cost) {
		cost = used[loop1].downc;
		insert = used[loop1].downn;
		fromn = used[loop1].number;
	    }
	    if (used[loop1].leftdownx != 0
		&& !isUsed(used[loop1].leftdownn)
		&& (used[loop1].leftdownc <= cost)) {
		cost = used[loop1].leftdownc;
		insert = used[loop1].leftdownn;
		fromn = used[loop1].number;
	    }
	    if (used[loop1].rightdownx != 0
		&& !isUsed(used[loop1].rightdownn)
		&& (used[loop1].rightdownc <= cost)) {
		cost = used[loop1].rightdownc;
		insert = used[loop1].rightdownn;
		fromn = used[loop1].number;
	    }
	    if (used[loop1].leftupx != 0
		&& !isUsed(used[loop1].leftupn)
		&& (used[loop1].leftupc <= cost)) {
		cost = used[loop1].leftupc;
		insert = used[loop1].leftupn;
		fromn = used[loop1].number;
	    }
	    if (used[loop1].rightupx != 0
		&& !isUsed(used[loop1].rightupn)
		&& (used[loop1].rightupc <= cost)) {
		cost = used[loop1].rightupc;
		insert = used[loop1].rightupn;
		fromn = used[loop1].number;
	    }
	}
	if (insert != 0) {
	    used[usedc]	= nodeNumber(insert);
	    costs[usedc] = cost;
	    fromNode[usedc] = fromn;
	    maxCost += cost;
	    usedc++;
	    return true;
	}
	return false;
    }
}
